.586
.model flat,stdcall
.mmx
option casemap:none

include	 \masm32\include\windows.inc
include	 \masm32\include\kernel32.inc
include	 \masm32\include\user32.inc
include	 \masm32\include\comctl32.inc
include	 \masm32\include\gdi32.inc

includelib	 \masm32\lib\kernel32.lib
includelib	 \masm32\lib\user32.lib
includelib	 \masm32\lib\comctl32.lib
includelib	 \masm32\lib\gdi32.lib

include		Lib\pnglib.inc
includelib	Lib\pnglib.lib

WinMain				PROTO	:HINSTANCE,:HINSTANCE,:LPSTR,:SDWORD
WndProc				PROTO	:HWND,:UINT,:WPARAM,:LPARAM
LoadPng				PROTO	:DWORD,:DWORD
PreMul				PROTO	:DWORD
AlphaBlend2			PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
RefreshFrame		PROTO	

.const
ID_FRAME		equ		500
ID_BUTTON		equ		400
ID_CURSOR		equ		50
ID_ICON			equ		200
;Our Frame .PNG is 403 x 287 Pixels
Frame_Size_X			equ		403 
Frame_Size_Y			equ		287
;;;;;;;;;;;;;; 
;Our Button .PNG is 46 x 69 Pixels
Button_Size_X			equ		46  ; .PNG  Pixel width
Button_Size_Y			equ		23  ; .PNG  Pixel Hieght/3 
;;;;;;;;;;;;
Button_Left			    equ		300 
Button_Right			equ		Button_Left + Button_Size_X - 1
Button_Top			    equ		30
Button_Bottom			equ		Button_Top + Button_Size_Y - 1
;;;;;;;;;;;;

; Hover mask
H_MAIN				equ		00001b
H_BUTTON			equ		01000b

CursorSpeed			equ		500

.data
ClassName			db	"3StateButtons",0
AppName				db	"Button Test",0
ptZero				POINT	<0,0>
blender				BLENDFUNCTION	<AC_SRC_OVER,0,0,AC_SRC_ALPHA>
BIH					BITMAPINFOHEADER	<sizeof(BITMAPINFOHEADER),Frame_Size_X,Frame_Size_Y,1,32,BI_RGB,NULL,NULL,NULL,NULL,NULL>

.data?
hInstance				HINSTANCE	?
hWin				dd		?
; PNG related
dcScreen			dd		?
dcMem				dd		?
dibMain				dd		?
dibFrame			dd		?
bFrame				dd		?
bExit			    dd		?
hOldBmp				dd		?
sizeFrame			dd		?,?
sizeButton			dd		?,?
Transparency		dd		?
bm					BITMAP	<>
pBblank				dd		?
dcTxt				dd		?
bTxt 				dd		?
; Mouse tracking
TME					TRACKMOUSEEVENT <>
MouseInside			BOOL	?
; Window moving
MoveDlg				BOOL	?
Rect					RECT	<>
OldPos				POINT	<>
NewPos				POINT	<>
; Hover stuff
hitpoint				POINT	<>
HOVER_FLAG			db		?
BTN_FLAG			BOOL	?
ButtonCol			BOOL	?



.code
start:
invoke GetModuleHandle, NULL
mov    hInstance,eax
invoke InitCommonControls
invoke WinMain, hInstance,NULL,NULL, SW_SHOWDEFAULT
invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
	LOCAL wc:WNDCLASSEX, msg:MSG
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov   wc.lpfnWndProc, offset WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,ID_ICON
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,hInst,ID_CURSOR
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke GetSystemMetrics,SM_CXSCREEN
	sub eax,Frame_Size_X  
	shr eax,1
	push eax
	invoke GetSystemMetrics,SM_CYSCREEN
	sub eax,Frame_Size_Y  
	shr eax,1
	pop ebx
	invoke CreateWindowEx,WS_EX_LAYERED,addr ClassName,addr AppName,WS_POPUP,ebx,eax,Frame_Size_X,Frame_Size_Y,NULL,NULL,hInst,NULL
	mov hWin,eax
	invoke ShowWindow, hWin,SW_SHOWNORMAL
	invoke UpdateWindow, hWin

	.while TRUE
		invoke GetMessage, addr msg,NULL,0,0
		.break .if (!eax)
		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg
	.endw
	mov eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_CREATE
	
	; Load PNGs
		invoke LoadPng,ID_FRAME,addr sizeFrame
		mov bFrame,eax
		invoke LoadPng,ID_BUTTON,addr sizeButton
		mov bExit,eax
; Prepare main canvas
		invoke GetDC,0
		mov dcScreen,eax
		invoke CreateDIBSection, dcScreen, addr BIH, DIB_RGB_COLORS, addr pBblank, NULL, NULL
		mov dibMain,eax
		invoke CreateCompatibleDC,dcScreen
		mov dcMem,eax
		invoke CreateDIBSection, dcMem, addr BIH, DIB_RGB_COLORS, addr pBblank, NULL, NULL
		mov dibFrame,eax
		invoke SelectObject,dcMem,dibFrame
		mov hOldBmp,eax

; Copy frame bitmap into main canvas
		invoke GetObject,bFrame,sizeof bm,addr bm
		mov esi,bm.bmBits
		invoke GetObject,dibMain,sizeof bm,addr bm
		mov edi,bm.bmBits
		mov eax,bm.bmHeight
		mul bm.bmWidth
		mov ebx,eax
	@@:	mov eax,[esi]
		mov [edi],eax
		add esi,4
		add edi,4
		dec ebx
		jnz @B

		;invoke InitKey
		invoke SetWindowPos,hWnd,0,0,0,Frame_Size_X,Frame_Size_Y,SWP_NOZORDER or SWP_NOMOVE
		invoke ShowWindow,hWnd,SW_SHOW
		invoke SetTimer,hWnd,777,CursorSpeed,NULL 
	; Init TRACKMOUSEEVENT
		mov TME.cbSize, sizeof TME
		push hWnd
		pop TME.hwndTrack
		mov TME.dwFlags, TME_LEAVE

		add blender.SourceConstantAlpha,220
	invoke UpdateLayeredWindow,hWnd,dcScreen,NULL,offset sizeFrame,dcMem,offset ptZero,0,offset blender,ULW_ALPHA



	.elseif uMsg==WM_LBUTTONDOWN
		.if HOVER_FLAG==H_MAIN || HOVER_FLAG==NULL
			mov MoveDlg,TRUE
			invoke SetCapture,hWnd
			invoke GetCursorPos,addr OldPos
		.else
			mov BTN_FLAG, TRUE
			invoke RefreshFrame
		.endif
		
	.elseif uMsg==WM_MOUSEMOVE
		mov eax,lParam
		and eax,0ffffh
		mov hitpoint.x,eax
		mov eax,lParam
		shr eax,16
		mov hitpoint.y,eax
		.if hitpoint.x >= Button_Left && hitpoint.x <= Button_Right && hitpoint.y >= Button_Top && hitpoint.y <= Button_Bottom   ; Button button hovered ?
			.if ButtonCol == FALSE
				mov HOVER_FLAG, H_BUTTON
				invoke RefreshFrame
				mov ButtonCol, TRUE
			.endif

		.elseif MoveDlg==TRUE
			invoke GetWindowRect,hWnd,addr Rect
			invoke GetCursorPos,addr NewPos
			mov eax,NewPos.x
			mov ecx,eax
			sub eax,OldPos.x
			mov OldPos.x,ecx
			add eax,Rect.left
			mov ebx,NewPos.y
			mov ecx,ebx
			sub ebx,OldPos.y
			mov OldPos.y,ecx
			add ebx,Rect.top
			mov ecx,Rect.right
			sub ecx,Rect.left
			mov edx,Rect.bottom
			sub edx,Rect.top
			invoke MoveWindow,hWnd,eax,ebx,ecx,edx,TRUE
		.else
			mov HOVER_FLAG, H_MAIN
			.if ButtonCol == TRUE
				mov ButtonCol, FALSE
				invoke RefreshFrame
			
			.endif
		.endif
		.if MouseInside==FALSE
			mov MouseInside,TRUE
			invoke TrackMouseEvent,addr TME
		.endif
	
	.elseif uMsg==WM_LBUTTONUP
	.if HOVER_FLAG==H_BUTTON
		invoke PostMessage,hWnd,WM_CLOSE,0,0
		
		.else
			mov MoveDlg,FALSE
			invoke ReleaseCapture
		.endif
		
		mov BTN_FLAG, FALSE
		invoke RefreshFrame

  	.elseif uMsg==WM_RBUTTONDOWN
		invoke ShowWindow,hWnd,SW_MINIMIZE

	.elseif uMsg==WM_MOUSELEAVE
		mov HOVER_FLAG,0
		mov MouseInside, FALSE
		.if ButtonCol == TRUE
			mov ButtonCol, FALSE

		.endif

	.elseif uMsg==WM_TIMER

	invoke RefreshFrame
		
	.elseif uMsg==WM_CLOSE

		invoke PostMessage,hWnd,WM_DESTROY,0,0

 	.elseif uMsg==WM_DESTROY
		invoke KillTimer,hWnd,777
		invoke SelectObject,dcMem,hOldBmp
		invoke DeleteDC,dcMem
		invoke ReleaseDC,hWnd,dcScreen
		invoke DeleteObject,bFrame
		invoke PostQuitMessage,NULL
		
  	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.endif
	
	xor eax,eax
	ret
WndProc endp

LoadPng proc ID:DWORD,pSize:DWORD
	LOCAL pngInfo:PNGINFO

	invoke PNG_Init, addr pngInfo
	invoke PNG_LoadResource, addr pngInfo, hInstance, ID
	.if !eax
		xor eax, eax
		jmp @cleanup
	.endif
	invoke PNG_Decode, addr pngInfo
	.if !eax
		xor eax, eax
		jmp @cleanup
	.endif
	invoke PNG_CreateBitmap, addr pngInfo, hWin, PNG_OUTF_AUTO, FALSE
	.if		!eax
		xor eax, eax
		jmp @cleanup
	.endif
	mov edi,pSize
	.if edi!=0
		lea esi,pngInfo
		movsd
		movsd
	.endif
	
@cleanup:
	push eax	
	invoke PNG_Cleanup, addr pngInfo
	
	pop eax
	ret

LoadPng endp

PreMul proc hBmp:DWORD
	LOCAL bminfo:BITMAP
	
	invoke GetObject,hBmp,sizeof bminfo,addr bminfo
	cmp bminfo.bmBitsPixel,32
	jne Abort
	mov esi,bminfo.bmBits
	mov edi,esi
yloop:
	mov ecx,bminfo.bmWidth
xloop:
	mov eax,dword ptr [esi]
	mov edx,eax
	shr eax,24
	mov bl,al
	add esi,4
	mul dl
	shr eax,8
	stosb
	mov al,bl
	shr edx,8
	mul dl
	shr eax,8
	stosb
	mov al,bl
	shr edx,8
	mul dl
	shr eax,8
	stosb
	inc edi
	dec ecx
	jnz xloop
	dec bminfo.bmHeight
	jnz yloop
Abort:
	ret

PreMul endp

AlphaBlend2 proc hSrcBm:DWORD,srcx:DWORD,srcy:DWORD,srcw:DWORD,srch:DWORD,hDstBm:DWORD,dstx:DWORD,dsty:DWORD
	
	LOCAL bmsrc:BITMAP, bmdst:BITMAP
	LOCAL srci:DWORD, dsti:DWORD

	invoke GetObject,hSrcBm,sizeof bmsrc,addr bmsrc
	invoke GetObject,hDstBm,sizeof bmdst,addr bmdst
	
	mov eax,bmsrc.bmWidth
	sub eax,srcw
	shl eax,2
	mov srci,eax
	
	mov eax,bmdst.bmWidth
	sub eax,srcw
	shl eax,2
	mov dsti,eax
	
	mov eax,bmdst.bmWidth
	mov edx,bmdst.bmHeight
	sub edx,dsty
	sub edx,srch
	mul edx
	add eax,dstx
	shl eax,2
	add eax,bmdst.bmBits
	mov edx,eax
	push edx
	
	mov eax,bmsrc.bmWidth
	mov edx,bmsrc.bmHeight
	sub edx,srcy
	sub edx,srch
	mul edx
	add eax,srcx
	shl eax,2
	add eax,bmsrc.bmBits
	
	pop edx
	
	shr srcw,1
	
	; This code by bitRAKE
.data
	__FF000000FF000000 dq 0FF000000FF000000h
	__00FFFFFF00FFFFFF dq 000FFFFFF00FFFFFFh
.code
	
AlphaBlendLoop: ; 13056 ticks for 1000 quads on Athlon. 
    mov ecx,srcw ; number of pixels/2 
    dec ecx 
    pxor mm7,mm7 
    movq mm0,[eax+ecx*8] 
    movq mm1,[edx+ecx*8]
@@:	movq mm4,mm0
	movq mm6,mm0
	psrlw mm6,1 ; optional effect
	paddusb mm6,mm1
	pand mm6,__FF000000FF000000
    movq mm2,mm0 
    psrlw mm4,1 
    movq mm3,mm1 
    movq mm5,mm4 
    punpcklbw mm0,mm7 
    punpcklbw mm1,mm7 
    punpckhbw mm2,mm7 
    punpckhbw mm3,mm7 
    psubsw mm0,mm1 
    psubsw mm2,mm3 
    punpcklwd mm4,mm4 
    punpckhwd mm5,mm5 
    punpckhdq mm4,mm4 
    punpckhdq mm5,mm5
    psllw mm0,1 
    psllw mm2,1 
    pmulhw mm0,mm4 
    pmulhw mm2,mm5
    paddsw mm0,mm1 
    paddsw mm2,mm3 
    packuswb mm0,mm2
	pand mm0,__00FFFFFF00FFFFFF
	por mm0,mm6
    ; stored alpha = (-dA * sA)/256 + dA (better!?)
    movq [edx+ecx*8],mm0
    dec ecx 
    js @F	; It crashes when I don't add this???
    movq mm0,[eax+ecx*8] 
    movq mm1,[edx+ecx*8] 
    jns @B
@@:
    mov ecx,srcw
    shl ecx,3
    add eax,ecx
    add edx,ecx    
    add eax,srci
    add edx,dsti
    dec srch
    jnz AlphaBlendLoop
    
	ret

AlphaBlend2 endp


RefreshFrame proc

; Restore frame without buttons	
	invoke GetObject,dibMain,sizeof bm,addr bm
	mov esi,bm.bmBits
	invoke GetObject,dibFrame,sizeof bm,addr bm
	mov edi,bm.bmBits
	mov eax,bm.bmHeight
	mul bm.bmWidth
	mov ebx,eax
@@:	mov eax,[esi]
	mov [edi],eax
	add esi,4
	add edi,4
	dec ebx
	jnz @B
;;;;;;;;;;;;;
;;;;;;;;;;;;;	
; Paste Button
	.if HOVER_FLAG==H_BUTTON
		.if  BTN_FLAG==TRUE
			mov eax,0
		.else
			mov eax,Button_Size_Y 
		.endif
	.else
		mov eax,Button_Size_Y*2
	.endif
	invoke AlphaBlend2,bExit,0,eax,Button_Size_X,Button_Size_Y,dibFrame,Button_Left,Button_Top
;;;;;;;;;;;;;
;;;;;;;;;;;;;	
; Update window	
	invoke PreMul,dibFrame
	invoke UpdateLayeredWindow,hWin,dcScreen,NULL,offset sizeFrame,dcMem,offset ptZero,0,offset blender,ULW_ALPHA
	ret
RefreshFrame endp

end start
